Resolution: Affected version:

Description

When a user record is destroyed, custom field values for custom fields with field_format == 'user' referencing the destroyed user are
left unchanged.

This leads to problems with queries on such a custom field when using either the none or any operators, since these match against
custom_values.value (not) being null or " - records that have the destroyed user's ID set will not turn up in the none query, but in the
any query, despite being displayed with an empty value in the Ul.

The attached patch adds a test case and addresses the issue by removing custom_values records that reference the destroyed user.

Related issues:
Has duplicate Redmine - Feature #8443: Removing CustomValue with related User... Closed 2011-05-26

Associated revisions

Revision 21207 - 2021-09-06 20:30 - Marius BALTEANU

Remove references to deleted user from "user"-Format CustomFields when destroying an user (#32977).

Patch by Jens Kramer.

Revision 21208 - 2021-09-06 20:33 - Marius BALTEANU
Use ids instead of pluck(:id) (#32977).

History

#1 - 2020-02-10 10:14 - Go MAEDA

- Target version set to Candidate for next minor release

#2 - 2020-02-10 10:48 - Marius BALTEANU

We shouldn't add a migration to remove the existing orphaned values?

#3 - 2020-02-10 14:56 - Jens Kramer

we should indeed do that. I'll take care of that tomorrow.

#4 - 2020-02-11 06:29 - Jens Kramer

- File 0001-removes-references-to-deleted-users-in-custom-field-.patch added

here's a new patch including a migration to delete already existing orphaned values.

#5 - 2020-02-11 07:03 - Go MAEDA

- Target version changed from Candidate for next minor release to Candidate for next major release

The patch cannot be committed for minor releases because it has a migration.

#6 - 2020-02-18 03:59 - Go MAEDA
- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next major release to 4.2.0
Setting the target version to 4.2.0.

#7 - 2021-03-23 21:47 - Marius BALTEANU
- Target version changed from 4.2.0 to 5.0.0

#8 - 2021-08-10 22:18 - Marius BALTEANU
- Status changed from New to Needs feedback

- Assignee changed from Jean-Philippe Lang to Jens Krdmer

Jens, I've reviewed the patch and it looks good to me, except the test that fails:

I redmine git: (patch/32977) 0 ruby test/unit/user_test.rb -n test_remove_custom_field_references_upon_destroy
Skipping LDAP tests.
Run options: -n test_remove_custom_field_references_upon_destroy —--seed 57996

# Running:
(B

Failure:
UserTest#test_remove_custom_field_references_upon_destroy [test/unit/user_test.rb:1341]:
#<Proc:0x00007fcf93fa35d8R@test/unit/user_test.rb:1341 (lambda)> didn't change by -2.
Expected: 20

Actual: 19

| think the problem is in the test because the following update:

issue.update (custom_field_values:
{

cfl.id => @jsmith.id,

cf2.id => [@dlopper.id, @jsmith.id]
1)

generates 3 entries in CustomValue (one for each user) and we should expect 3 less custom values when the user jsmith is destroyed.

diff --git a/test/unit/user_test.rb b/test/unit/user_test.rb

index e2dec070c..42011£f759 100644

—-—— a/test/unit/user_test.rb

+++ b/test/unit/user_test.rb

@@ -1336,7 +1336,7 Q@ class UserTest < ActiveSupport::TestCase
assert cv2a = cv2.detect{|cv| cv.value == @dlopper.id.to_s}
assert cv2b = cv2.detect{|cv]| cv.value == @jsmith.id.to_s}

= assert_difference ->{CustomValue.count}, -2 do
+ assert_difference —>{CustomValue.count}, -3 do

@jsmith.destroy
end

#9 - 2021-08-24 09:24 - Jens Kramer
| just tried and it passes here (MySQL 5.6, Ruby 2.6).

Since we delete jsmith (but not dlopper), the custom value for @dlopper should not be affected. | have no clue why the test fails for you though.

#10 - 2021-09-04 13:30 - Marius BALTEANU
- Assignee changed from Jens Krdmer to Marius BALTEANU

Jens Kramer wrote:
I just tried and it passes here (MySQL 5.6, Ruby 2.6).

Since we delete jsmith (but not dlopper), the custom value for @dlopper should not be affected. | have no clue why the test fails for you though.

Thanks, you're right, user @dlopper should not be affected, | will take again a look. It doesn't fail only on my local environment, it fails also on the
custom Gitlab ClI.

#11 - 2021-09-04 13:30 - Marius BALTEANU

- Status changed from Needs feedback to New
https://gitlab.com/redmine-org/redmine/-/jobs/1468533588#L1668

#12 - 2021-09-05 18:21 - Marius BALTEANU

Jens Kramer wrote:

Since we delete jsmith (but not dlopper), the custom value for @dlopper should not be affected. | have no clue why the test fails for you though.

The number of CustomValue decreases with 3 not because of those 3 values that are added during the tests (as | wrongly said first time), but

because @jsmith user has also a CustomValue of type User (CustomValue#3) which is deleted as well when user is destroyed.

Jens, it should fail also on your environment if you use the default Redmine fixtures.
I'm going to change the user in the tests and | will commit this fix.

#13 - 2021-09-06 20:34 - Marius BALTEANU

- Status changed from New to Resolved

#14 - 2021-09-06 20:35 - Marius BALTEANU
Patch committed, thank you.
I've updated the tests to assert -3 custom values and | added a comment.

#15 - 2021-09-06 22:56 - Marius BALTEANU

- Status changed from Resolved to Closed

#16 - 2022-03-27 04:58 - Go MAEDA

- Tracker changed from Patch to Defect

#17 - 2023-05-08 03:46 - Go MAEDA

- Has duplicate Feature #8443: Removing CustomValue with related User object added

Files

0001-removes-references-to-deleted-users-in-custom-field-.patch 2.71 KB 2020-02-10 Jens Kramer

0001-removes-references-to-deleted-users-in-custom-field-.patch 3.65 KB 2020-02-11 Jens Kramer
https://github.com/redmine/redmine/blob/master/test/fixtures/custom_values.yml#L26
